
//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------
#include <SI_EFM8UB1_Register_Enums.h>                  // SFR declarations
#include "InitDevice.h"
#include "VCPXpress.h"
#include "descriptor.h"
#include "WirelessPower_Defs.h"

//-----------------------------------------------------------------------------
// main() Routine
// ----------------------------------------------------------------------------
int main (void)
{
	// Call hardware initialization routine
	enter_DefaultMode_from_RESET();

	// VCPXpress Initialization
	USB_Init(&InitStruct);

	// Enable VCPXpress API interrupts
	API_Callback_Enable(myAPICallback);

	// Enable global interrupts
	IE_EA = 1;

	//start Timer3 and thereby enable ADC conversions
	SFRPAGE = TIMER3_PAGE;
	TMR3CN0 |= TMR3CN0_TR3__RUN;

	while(1)
	{
		if(ADC_BUFFER_FULL == TRUE)
		{
			ADC_BUFFER_FULL = FALSE;

			if(ADC_DATA_REQUESTED == TRUE)
			{
				ADC_DATA_REQUESTED = FALSE;

				Transmit_USB_Packet();
			}

			else
			{
				//if the host has not requested data, restart Timer3 to continue ADC conversions
				SFRPAGE = TIMER3_PAGE;
				TMR3CN0 |= TMR3CN0_TR3__RUN;
			}
		}
	}
}
